
import java.util.Iterator;
import java.util.NoSuchElementException;

public class LinkedListGenericIterable<E> extends LinkedListGeneric<E> implements Iterable<E> {

    private class LLIterator implements Iterator<E> {

        private ListNode cur;

        private LLIterator(ListNode cur) {
            this.cur = cur;
        }
        @Override
        public boolean hasNext() {
            return cur != null;
        }
        @Override
        public E next() {
            if (cur == null) {
                throw new NoSuchElementException();
            }
            E ret = cur.item;
            cur = cur.next; //move forward
            return ret;
        }
    }
    @Override
    public Iterator iterator() {
        return new LLIterator(start);
    }
}
